您的位置:首页 > 产品设计 > UI/UE

Codeforces 678F Lena and Queries

2016-06-15 18:36 411 查看

题意:

你有一个点集,有三种操作:

往集合里插入一个点\((x, y)\)

从集合中删除第\(i\)次操作插入的点

对于给出的\(q\),询问点集中\(x \cdot q + y\)的最大值

分析:

先不考虑插入删除操作,对于一个给定的点集,如何寻找\(x \cdot q + y\)最大值

这是一个线性规划的问题,只是可行域变成了离散的点。

设\(x \cdot q + y = z\),其中\(z\)是优化目标。

\(y = -q \cdot x + z\),使得经过点\((x, y)\)斜率为\(-q\)的直线的截距最大。

那么作为最优解的点一定在点集的凸包上,所以可以用单调栈求出凸包,然后三分求最大值。

因为每次操作都可能导致点集发生变化,不可能每次都求一遍凸包。

每个节点对应一个生存期\([L, R]\),即在第\(L\)次操作到第\(R\)次操作中点集中有该点。

然后把它插入到一个线段树的区间中,这样线段树的每个点都对应一段操作区间的一个点集。

用这个点集的凸包更新所有这个区间的询问。

#include <cstdio>
#include <cstring>
#include <algorithm>
#include <vector>
using namespace std;

typedef long long LL;
const int maxn = 300000 + 10;
const LL INF = 1LL << 61;

struct Point
{
LL x, y;

Point(LL x = 0, LL y = 0): x(x), y(y) {}

void read() { scanf("%lld%lld", &x, &y); }

bool operator < (const Point& t) const {
return x < t.x || (x == t.x && y < t.y);
}

Point operator + (const Point& t) const {
return Point(x + t.x, y + t.y);
}

Point operator - (const Point& t) const {
return Point(x - t.x, y - t.y);
}
};

LL Cross(const Point& A, const Point& B) {
return A.x * B.y - A.y * B.x;
}

LL Dot(const Point& A, const Point& B) {
return A.x * B.x + A.y * B.y;
}

int type[maxn], top;
Point p[maxn], S[maxn];
vector<Point> v[maxn * 4];
bool del[maxn], empty[maxn];
LL ans[maxn];

void insert(int o, int L, int R, int qL, int qR, int v) {
if(qL <= L && R <= qR) {
::v[o].push_back(p[v]);
return;
}
int M = (L + R) / 2;
if(qL <= M) insert(o<<1, L, M, qL, qR, v);
if(qR > M) insert(o<<1|1, M+1, R, qL, qR, v);
}

void query(int x) {
int L = 1, R = top;
while(R - L >= 3) {
int mid1 = (L * 2 + R) / 3;
int mid2 = (L + R * 2) / 3;
if(Dot(p[x], S[mid1]) < Dot(p[x], S[mid2])) L = mid1;
else R = mid2;
}
for(int i = L; i <= R; i++)
ans[x] = max(ans[x], Dot(p[x], S[i]));
}

void solve(int o, int L, int R) {
if(L < R) {
int M = (L + R) / 2;
solve(o<<1, L, M);
solve(o<<1|1, M+1, R);
}

sort(v[o].begin(), v[o].end());
top = 0;
for(int i = 0; i < v[o].size(); i++) {
while(top > 1 && Cross(S[top]-S[top-1], v[o][i]-S[top]) >= 0) top--;
S[++top] = v[o][i];
}

for(int i = L; i <= R; i++) if(type[i] == 3 && !empty[i])
query(i);
}

int main()
{
int n; scanf("%d", &n);
int cnt = 0;
for(int i = 1; i <= n; i++) {
scanf("%d", type + i);
if(type[i] == 1) {
p[i].read();
cnt++;
} else if(type[i] == 2) {
int x; scanf("%d", &x);
del[x] = true;
cnt--;
insert(1, 1, n, x, i, x);
} else {
scanf("%lld", &p[i].x);
p[i].y = 1LL;
if(!cnt) empty[i] = true;
}
}

for(int i = 1; i <= n; i++)
if(type[i] == 1 && !del[i])
insert(1, 1, n, i, n, i);

for(int i = 1; i <= n; i++) ans[i] = -INF;
solve(1, 1, n);

for(int i = 1; i <= n; i++) if(type[i] == 3) {
if(empty[i]) printf("EMPTY SET\n");
else printf("%lld\n", ans[i]);
}

return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: